package connections

import (
	"gitlab.okta-solutions.com/mashroom/backend/account/api"
	"gitlab.okta-solutions.com/mashroom/backend/address/api"
	"gitlab.okta-solutions.com/mashroom/backend/auth/api"
	"gitlab.okta-solutions.com/mashroom/backend/cardpayment/api"
	"gitlab.okta-solutions.com/mashroom/backend/common/generic/env"
	"gitlab.okta-solutions.com/mashroom/backend/common/generic/grpc"
	"gitlab.okta-solutions.com/mashroom/backend/contract/api"
	"gitlab.okta-solutions.com/mashroom/backend/document/api"
	"gitlab.okta-solutions.com/mashroom/backend/extras/api"
	"gitlab.okta-solutions.com/mashroom/backend/geo/api"
	"gitlab.okta-solutions.com/mashroom/backend/invitation/api"
	"gitlab.okta-solutions.com/mashroom/backend/maintenance/api"
	"gitlab.okta-solutions.com/mashroom/backend/messaging/api"
	notification "gitlab.okta-solutions.com/mashroom/backend/notification/api"
	"gitlab.okta-solutions.com/mashroom/backend/oauth/api"
	"gitlab.okta-solutions.com/mashroom/backend/offer/api"
	"gitlab.okta-solutions.com/mashroom/backend/payment/api"
	"gitlab.okta-solutions.com/mashroom/backend/property/api"
	"gitlab.okta-solutions.com/mashroom/backend/rightmove/api"
	"gitlab.okta-solutions.com/mashroom/backend/signature/api"
	"gitlab.okta-solutions.com/mashroom/backend/twilio/api"
	"gitlab.okta-solutions.com/mashroom/backend/verification/api"
	"gitlab.okta-solutions.com/mashroom/backend/zoopla/api"
)

var AccountServiceUrl = env.ResolveString("ACCOUNT_SERVICE_URL", "mashroom-account:10000")
var AccountService = account.NewAccountServiceClient(grpc.Dial(AccountServiceUrl, "Account"))

var AuthServiceUrl = env.ResolveString("AUTH_SERVICE_URL", "mashroom-auth:10000")
var AuthService = auth.NewAuthServiceClient(grpc.Dial(AuthServiceUrl, "Auth"))

var ContractServiceUrl = env.ResolveString("CONTRACT_SERVICE_URL", "mashroom-contract:10000")
var ContractService = contract.NewContractServiceClient(grpc.Dial(ContractServiceUrl, "Contract"))

var InvitationServiceUrl = env.ResolveString("INVITATION_SERVICE_URL", "mashroom-invitation:10000")
var InvitationService = invitation.NewInvitationServiceClient(grpc.Dial(InvitationServiceUrl, "Invitation"))

var MessagingServiceUrl = env.ResolveString("MESSAGING_SERVICE_URL", "mashroom-messaging:10000")
var MessagingService = messaging.NewMessagingServiceClient(grpc.Dial(MessagingServiceUrl, "Messaging"))

var OfferServiceUrl = env.ResolveString("OFFER_SERVICE_URL", "mashroom-offer:10000")
var OfferService = offer.NewOfferServiceClient(grpc.Dial(OfferServiceUrl, "Offer"))

var PropertyServiceUrl = env.ResolveString("PROPERTY_SERVICE_URL", "mashroom-property:10000")
var PropertyService = property.NewPropertyServiceClient(grpc.Dial(PropertyServiceUrl, "Property"))

var VerificationServiceUrl = env.ResolveString("VERIFICATION_SERVICE_URL", "mashroom-verification:10000")
var VerificationService = verification.NewVerificationServiceClient(grpc.Dial(VerificationServiceUrl, "Verification"))

var AddressServiceUrl = env.ResolveString("ADDRESS_SERVICE_URL", "mashroom-address:10000")
var AddressService = address.NewAddressServiceClient(grpc.Dial(AddressServiceUrl, "Address"))

var GeoServiceUrl = env.ResolveString("GEO_SERVICE_URL", "mashroom-geo:10000")
var GeoService = geo.NewGeoServiceClient(grpc.Dial(GeoServiceUrl, "Geo"))

var SignatureServiceUrl = env.ResolveString("SIGNATURE_SERVICE_URL", "mashroom-signature:10000")
var SignatureService = signature.NewSignatureServiceClient(grpc.Dial(SignatureServiceUrl, "Signature"))

var OauthServiceUrl = env.ResolveString("OAUTH_SERVICE_URL", "mashroom-oauth:10000")
var OauthService = oauth.NewOAuthServiceClient(grpc.Dial(OauthServiceUrl, "Oauth"))

var DocumentServiceUrl = env.ResolveString("DOCUMENT_SERVICE_URL", "mashroom-document:10000")
var DocumentService = document.NewDocumentServiceClient(grpc.Dial(DocumentServiceUrl, "Document"))

var ExtrasServiceUrl = env.ResolveString("EXTRAS_SERVICE_URL", "mashroom-extras:10000")
var ExtrasService = extras.NewExtrasServiceClient(grpc.Dial(ExtrasServiceUrl, "Extras"))

var PaymentServiceUrl = env.ResolveString("PAYMENT_SERVICE_URL", "mashroom-payment:10000")
var PaymentService = payment.NewPaymentServiceClient(grpc.Dial(PaymentServiceUrl, "Payment"))

var CardPaymentServiceUrl = env.ResolveString("CARDPAYMENT_SERVICE_URL", "mashroom-cardpayment:10000")
var CardPaymentService = cardpayment.NewCardpaymentServiceClient(grpc.Dial(CardPaymentServiceUrl, "Cardpayment"))

var RightmoveServiceUrl = env.ResolveString("RIGHTMOVE_SERVICE_URL", "mashroom-rightmove:10000")
var RightmoveService = rightmove.NewRightmoveServiceClient(grpc.Dial(RightmoveServiceUrl, "Rightmove"))

var ZooplaServiceUrl = env.ResolveString("ZOOPLA_SERVICE_URL", "mashroom-zoopla:10000")
var ZooplaService = zoopla.NewZooplaServiceClient(grpc.Dial(ZooplaServiceUrl, "Zoopla"))

var MaintenanceServiceUrl = env.ResolveString("MAINTENANCE_SERVICE_URL", "mashroom-maintenance:10000")
var MaintenanceService = maintenance.NewMaintenanceServiceClient(grpc.Dial(MaintenanceServiceUrl, "Maintenance"))

var TwilioServiceUrl = env.ResolveString("TWILIO_SERVICE_URL", "mashroom-twilio:10000")
var TwilioService = twilio.NewTwilioServiceClient(grpc.Dial(TwilioServiceUrl, "Twilio"))

var NotificationServiceUrl = env.ResolveString("NOTIFICATION_SERVICE_URL", "mashroom-notification:10000")
var NotificationService = notification.NewNotificationServiceClient(grpc.Dial(NotificationServiceUrl, "Notification"))
