package resolvers

import (
	"github.com/graphql-go/graphql"
	"gitlab.okta-solutions.com/mashroom/backend/common/graphql/util"
	"gitlab.okta-solutions.com/mashroom/backend/gateway/impl/connections"
	"gitlab.okta-solutions.com/mashroom/backend/payment/api"
)

func init() {
	/*
		query := graphql.NewObject(graphql.ObjectConfig{
			Name:        "PaymentQuery",
			Description: "Payment query root",
			Fields: graphql.Fields{
				"get": &graphql.Field{
					Description: "Get transfer status",
					Args:        util.BindArguments(payment.GetTransferRequest{}),
					Resolve:     PaymentQueryTransferResolver,
					Type:        util.BindOutput(payment.GetTransferResponse{}, "Transfer status", nil),
				},
			},
		})

		schema.RootQueries["payment"] = &graphql.Field{
			Type: query,
			Resolve: func(p graphql.ResolveParams) (interface{}, error) {
				return query, nil
			},
		}

		mutation := graphql.NewObject(graphql.ObjectConfig{
			Name:        "PaymentMutation",
			Description: "Payment mutation root",
			Fields: graphql.Fields{
				"create": &graphql.Field{
					Description: "Create a transfer",
					Args:        util.BindArguments(payment.CreateTransferRequest{}),
					Resolve:     PaymentMutationCreateResolver,
					Type:        util.BindOutput(payment.CreateTransferResponse{}, "Create transfer", nil),
				},
				"redeem": &graphql.Field{
					Description: "Redeem token",
					Args:        util.BindArguments(payment.RedeemTokenRequest{}),
					Resolve:     PaymentMutationRedeemResolver,
					Type:        util.BindOutput(payment.RedeemTokenResponse{}, "Redeem token", nil),
				},
			},
		})
		schema.RootMutations["payment"] = &graphql.Field{
			Type: mutation,
			Resolve: func(p graphql.ResolveParams) (interface{}, error) {
				return mutation, nil
			},
		}
	*/
}

func PaymentQueryTransferResolver(params graphql.ResolveParams) (interface{}, error) {
	request := &payment.GetTransferRequest{}
	if err := util.UnmarshalArguments(params.Args, request); err != nil {
		return nil, err
	}
	return connections.PaymentService.GetTransfer(params.Context, request)
}

func PaymentMutationCreateResolver(params graphql.ResolveParams) (interface{}, error) {
	request := &payment.CreateTransferRequest{}
	if err := util.UnmarshalArguments(params.Args, request); err != nil {
		return nil, err
	}
	return connections.PaymentService.CreateTransfer(params.Context, request)
}

func PaymentMutationRedeemResolver(params graphql.ResolveParams) (interface{}, error) {
	request := &payment.RedeemTokenRequest{}
	if err := util.UnmarshalArguments(params.Args, request); err != nil {
		return nil, err
	}
	return connections.PaymentService.RedeemToken(params.Context, request)
}
